Package com.verisign.epp.codec.defReg

## Class EPPDefRegTransferCmd

- java.lang.Object
- - com.verisign.epp.codec.gen.EPPCommand
  - - com.verisign.epp.codec.gen.EPPTransferCmd
    - - com.verisign.epp.codec.defReg.EPPDefRegTransferCmd

- All Implemented Interfaces:
    `EPPCodecComponent`, `EPPMessage`, `java.io.Serializable`, `java.lang.Cloneable`

      public class EPPDefRegTransferCmd
      extends EPPTransferCmd

  Represents an EPP DefReg `<transfer>` command, which provides either a query operation that allows a client to determine real-time status of pending and completed transfer requests, or a transform operation that allows a client to manage requests to transfer the sponsorship of a defReg object. In addition to the standard EPP command elements, the `<transfer>` command MUST contain a `<defReg:transfer>` element that identifies the defReg namespace. The `<defReg:transfer>` element contains the following child elements:
  - A `<defReg:roid>` element that contains that contains the repository object identifier assigned to the defReg object when the object was created.
  - A `<defReg:period` element that contains the number of units to be added to the registration period of the defReg object at completion of the transfer process. This element is only applicable in a transform command where the "op" attribute of the EPP `<transfer>` command is set to "request".
  - An OPTIONAL `<defReg:authInfo>` element that contains authorization information associated with the defReg object or authorization information associated with the defReg object's registrant or associated contacts. An OPTIONAL "roid" attribute MUST be used to identify the registrant or contact object if and only if the given authInfo is associated with a registrant or contact object and not the defReg itself. If this element is not provided or if the authorization information is invalid, server policy determines if the command is rejected or if response information will be returned to the client.
  See Also:
    `EPPDefRegTransferResp`, Serialized Form

- - ### Field Summary

    - ### Fields inherited from class com.verisign.epp.codec.gen.EPPTransferCmd

      `op`

    - ### Fields inherited from class com.verisign.epp.codec.gen.EPPCommand

      `extensions, OP_APPROVE, OP_CANCEL, OP_QUERY, OP_REJECT, OP_REQUEST, transId, TYPE_CHECK, TYPE_CREATE, TYPE_DELETE, TYPE_INFO, TYPE_LOGIN, TYPE_LOGOUT, TYPE_POLL, TYPE_RENEW, TYPE_TRANSFER, TYPE_UPDATE`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `EPPDefRegTransferCmd()` | Allocates a new `EPPDefRegTransferCmd` with default attribute values.
    `EPPDefRegTransferCmd​(java.lang.String aTransId, java.lang.String aOp, java.lang.String aRoid)` | `EPPDefRegTransferCmd` constructor that takes the required attributes as arguments.
    `EPPDefRegTransferCmd​(java.lang.String aTransId, java.lang.String aOp, java.lang.String aRoid, EPPAuthInfo aAuthInfo, EPPDefRegPeriod aPeriod)` | `EPPDefRegTransferCmd` constructor that takes the required attributes plus the optional attibute `aPeriod`.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.Object` | `clone()` | Clone `EPPDefRegTransferCmd`.
    `protected void` | `doDecode​(org.w3c.dom.Element aElement)` | Decode the `EPPDefRegTransferCmd` attributes from the aElement DOM Element tree.
    `protected org.w3c.dom.Element` | `doEncode​(org.w3c.dom.Document aDocument)` | Encode a DOM Element tree from the attributes of the `EPPDefRegTransferCmd` instance.
    `boolean` | `equals​(java.lang.Object aObject)` | Compare an instance of `EPPDefRegTransferCmd` with this instance.
    `EPPAuthInfo` | `getAuthInfo()` | Get authorization information
    `java.lang.String` | `getKey()` | Gets the key for the defensive registration object, which is the defensive registration ROID.
    `java.lang.String` | `getNamespace()` | Gets the EPP command Namespace associated with `EPPDefRegTransferCmd`.
    `EPPDefRegPeriod` | `getPeriod()` | Gets the registration period of the transfer command in years.
    `java.lang.String` | `getRoid()` | Gets the defReg name to query.
    `void` | `setAuthInfo​(EPPAuthInfo newAuthInfo)` | Set authorization information
    `void` | `setPeriod​(EPPDefRegPeriod aPeriod)` | Sets the registration period of the transfer command.
    `void` | `setRoid​(java.lang.String aRoid)` | Sets the defReg name to query.
    `java.lang.String` | `toString()` | Implementation of `Object.toString`, which will result in an indented XML `String` representation of the concrete `EPPCodecComponent`.

    - ### Methods inherited from class com.verisign.epp.codec.gen.EPPTransferCmd

      `doGenDecode, doGenEncode, getOp, getType, setOp`

    - ### Methods inherited from class com.verisign.epp.codec.gen.EPPCommand

      `addExtension, decode, encode, findDuplicateExtNamespaces, findExtNamespaces, findExtNamespaceSuffixes, findUnsupportedExtNamespaces, findUnsupportedExtNamespaceSuffixes, getExtension, getExtension, getExtensions, getTransId, hasExtension, hasExtensions, hasKey, hasTransId, setExtension, setExtensions, setTransId`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### EPPDefRegTransferCmd

          public EPPDefRegTransferCmd()

      Allocates a new `EPPDefRegTransferCmd` with default attribute values. the defaults include the following:
      - roid is set to `null`
      - period is set to `null`
      - authInfo is set to to `null`
      The transaction ID, operation, name, and authInfo must be set before invoking `encode`.

    - #### EPPDefRegTransferCmd

          public EPPDefRegTransferCmd​(java.lang.String aTransId,
                                      java.lang.String aOp,
                                      java.lang.String aRoid)

      `EPPDefRegTransferCmd` constructor that takes the required attributes as arguments. The period attribute is set to `UNSPEC_PERIOD` and will not be included when `encode` is invoked.
      Parameters:
        `aTransId` - Transaction Id associated with the command.
        `aOp` - One of the `EPPCommand.OP_` constants associated with the transfer command.
        `aRoid` - DefReg roid to create.

    - #### EPPDefRegTransferCmd

          public EPPDefRegTransferCmd​(java.lang.String aTransId,
                                      java.lang.String aOp,
                                      java.lang.String aRoid,
                                      EPPAuthInfo aAuthInfo,
                                      EPPDefRegPeriod aPeriod)

      `EPPDefRegTransferCmd` constructor that takes the required attributes plus the optional attibute `aPeriod`.
      Parameters:
        `aTransId` - Transaction Id associated with the command.
        `aOp` - One of the `EPPCommand.OP_` constants associated with the transfer command.
        `aRoid` - DefReg roid to create.
        `aAuthInfo` - Authorization Information for operating with the defReg.
        `aPeriod` - Registration period to be added to the defReg upon transfer.

  - ### Method Detail

    - #### getNamespace

          public java.lang.String getNamespace()

      Gets the EPP command Namespace associated with `EPPDefRegTransferCmd`.
      Specified by:
        `getNamespace` in interface `EPPCodecComponent`
      Specified by:
        `getNamespace` in interface `EPPMessage`
      Specified by:
        `getNamespace` in class `EPPCommand`
      Returns:
        `EPPDefRegMapFactory.NS`

    - #### getKey

          public java.lang.String getKey()

      Gets the key for the defensive registration object, which is the defensive registration ROID.
      Overrides:
        `getKey` in class `EPPCommand`
      Returns:
        The defensive registration ROID if set; `null` otherwise.

    - #### getAuthInfo

          public EPPAuthInfo getAuthInfo()

      Get authorization information
      Returns:
        EPPAuthInfo

    - #### setAuthInfo

          public void setAuthInfo​(EPPAuthInfo newAuthInfo)

      Set authorization information
      Parameters:
        `newAuthInfo` - java.lang.String

    - #### doEncode

          protected org.w3c.dom.Element doEncode​(org.w3c.dom.Document aDocument)
                                          throws EPPEncodeException

      Encode a DOM Element tree from the attributes of the `EPPDefRegTransferCmd` instance.
      Specified by:
        `doEncode` in class `EPPTransferCmd`
      Parameters:
        `aDocument` - DOM Document that is being built. Used as an Element factory.
      Returns:
        Root DOM Element representing the `EPPDefRegTransferCmd` instance.
      Throws:
        `EPPEncodeException` - Unable to encode `EPPDefRegTransferCmd` instance.

    - #### doDecode

          protected void doDecode​(org.w3c.dom.Element aElement)
                           throws EPPDecodeException

      Decode the `EPPDefRegTransferCmd` attributes from the aElement DOM Element tree.
      Specified by:
        `doDecode` in class `EPPTransferCmd`
      Parameters:
        `aElement` - Root DOM Element to decode `EPPDefRegTransferCmd` from.
      Throws:
        `EPPDecodeException` - Unable to decode aElement

    - #### getRoid

          public java.lang.String getRoid()

      Gets the defReg name to query.
      Returns:
        DefReg Name if defined; `null` otherwise.

    - #### setRoid

          public void setRoid​(java.lang.String aRoid)

      Sets the defReg name to query.
      Parameters:
        `aRoid` - DefReg Name

    - #### getPeriod

          public EPPDefRegPeriod getPeriod()

      Gets the registration period of the transfer command in years.
      Returns:
        Registration Period in years if defined; `null` otherwise.

    - #### setPeriod

          public void setPeriod​(EPPDefRegPeriod aPeriod)

      Sets the registration period of the transfer command.
      Parameters:
        `aPeriod` - Registration Period.

    - #### equals

          public boolean equals​(java.lang.Object aObject)

      Compare an instance of `EPPDefRegTransferCmd` with this instance.
      Overrides:
        `equals` in class `EPPTransferCmd`
      Parameters:
        `aObject` - Object to compare with.
      Returns:
        DOCUMENT ME!

    - #### clone

          public java.lang.Object clone()
                                 throws java.lang.CloneNotSupportedException

      Clone `EPPDefRegTransferCmd`.
      Specified by:
        `clone` in interface `EPPCodecComponent`
      Overrides:
        `clone` in class `EPPTransferCmd`
      Returns:
        clone of `EPPDefRegTransferCmd`
      Throws:
        `java.lang.CloneNotSupportedException` - standard Object.clone exception

    - #### toString

          public java.lang.String toString()

      Implementation of `Object.toString`, which will result in an indented XML `String` representation of the concrete `EPPCodecComponent`.
      Overrides:
        `toString` in class `EPPCommand`
      Returns:
        Indented XML `String` if successful; `ERROR` otherwise.